freeslot("SPR_SJET", "MT_SAMJETSTREAM",
	"S_SAMJETSTREAM_SPAWN", "S_SAMJETSTREAM_ATTACK",
	"SFX_JETSA1", "SFX_JETSA2", "SFX_JETSA3", "SFX_JBASED")
	
local jetstreamvictim = {}

local function JetStreamVictims(var)
	jetstreamvictim = {}
	local yayliveplayer = #players-1
		for i = 0, yayliveplayer
			if players[i]
			and players[i].valid
				if not players[i].spectator
				and players[i].mo
				and players[i].mo.valid
				and players[i].nblive
				table.insert(jetstreamvictim, players[i].mo)
			end
		end
	end
end

addHook("ThinkFrame", function(mo)
	JetStreamVictims()
end)

addHook("PlayerThink", function(player)
	if player.mo
	and player.mo.valid
		if player.playerstate == PST_LIVE
			if player.mo.nbpst != 1
				player.mo.nbpst = 1
				player.nblive = true
				player.nbdead = nil
			end
		else
			if player.mo.nbpst != 0
				player.mo.nbpst = 0
				player.nblive = nil
				player.nbdead = true
			end
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo
	and mo.valid
	and mo.health
		mo.shadowscale = 0
		mo.scale = FRACUNIT/2
		mo.scale = FRACUNIT/2
		if mo.delayattack == nil
			mo.delayattack = 0
		end
		if not S_IdPlaying(sfx_jbased)
			S_StartSound(mo, sfx_jbased)
		end
		if (mo.state == S_SAMJETSTREAM_SPAWN)
			if mo.target == nil
				if mo.delayattack != 0
					mo.delayattack = $ - 1
				else
					local prandom = P_RandomRange(1, #jetstreamvictim)
					if jetstreamvictim[prandom]
					and jetstreamvictim[prandom].valid
						mo.target = jetstreamvictim[prandom].player.mo
						if not S_IdPlaying(sfx_jetsa3)
							S_StartSound(nil, sfx_jetsa3, target)
						end
						mo.state = S_SAMJETSTREAM_ATTACK
					end
				end
			end
		end
		if (mo.state != S_SAMJETSTREAM_SPAWN)
			local jsstrust = P_RandomRange(26,30)*FRACUNIT
			P_InstaThrust(mo, R_PointToAngle2(mo.x, mo.y, mo.target.x, mo.target.y), jsstrust)
			P_SpawnGhostMobj(mo)
			if mo.target == nil or mo.target.nbpst == 0
				S_StartSound(mo, sfx_jetsa2)
				S_StartSound(mo, sfx_jetsa1)
				mo.delayattack = 60
				mo.momx = 0
				mo.momy = 0
				mo.momz = 0
				mo.target = nil
				mo.state = S_SAMJETSTREAM_SPAWN
			end
			if mo.target
				for player in players.iterate do
					local sam_distance_xy = R_PointToDist2(mo.x, mo.y, player.mo.x, player.mo.y) 
					local sam_distance_z = P_AproxDistance(0, player.mo.z-mo.z)
					if sam_distance_xy <= 1280*FRACUNIT
					and sam_distance_z <= 1280*FRACUNIT
						mo.target = player.mo
					end
				end
			end
		end
	end
end, MT_SAMJETSTREAM)

COM_AddCommand("bloodshed", function(player, arg)
	if not player.mo
		print(player, "You can't spawn it, when you're dead!")
		return
	end
	if arg == "kill"
		for mobj in mobjs.iterate() do
			if mobj.type == MT_SAMJETSTREAM
				mobj.state = S_NULL
			end
		end
	end
	if not arg
		if leveltime > 1
			P_SpawnMobj((player.mo.x + 256*FRACUNIT), (player.mo.y + 256*FRACUNIT), (player.mo.z + 32*FRACUNIT), MT_SAMJETSTREAM)
		end
	end
end, 1)